// PanViewerView.h : interface of the CPanViewerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANVIEWERVIEW_H__EDC98D59_E8BC_447D_AF4D_32CD209A8207__INCLUDED_)
#define AFX_PANVIEWERVIEW_H__EDC98D59_E8BC_447D_AF4D_32CD209A8207__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Effect.h"
#include "EffectFactory.h"
#include "WindowVirt.h"

//
// CLASS: CPanViewerView
//
// PURPOSE: Toplevel document window for a Pan image. Also capable
//          of instantiating new image effects. Used by the SDI
//          frame.
class CPanViewerView : public CWindowImpl<CPanViewerView,CWindowVirt>
{
public:
//	DECLARE_WND_CLASS(NULL)
    DECLARE_WND_CLASS_EX2(NULL, 0)

    CPanViewerView(int* pDisplayPasses, double *pMaxJitter)
        : m_image(NULL), m_pDisplayPasses(pDisplayPasses), m_pMaxJitter(pMaxJitter)
    { m_imgFact = new CEffectFactory(pDisplayPasses,pMaxJitter, m_bstrDocURL); }

    ~CPanViewerView() { delete m_image; delete m_imgFact; }

	BOOL PreTranslateMessage(MSG* pMsg)
	{
		pMsg;
		return FALSE;
	}

    void SetDocumentURL(CComBSTR docURL)
    {
         m_bstrDocURL = docURL;
         if (m_imgFact) {
             m_imgFact->SetDocumentURL(m_bstrDocURL);
         }
    }

    void SetMainHWND(HWND hWnd) 
    { 
        if (m_imgFact) {
            m_imgFact->SetMainHWND(hWnd);
        }
        if (m_image) {
            m_image->SetMainHWND(hWnd);
        }
    }

    SIZE OpenEffect(HWND hWnd, PTSTR fName, CPerfData* pData, LPTSTR& effectName);
    SIZE OpenEffect(HWND hWnd, REFCLSID clsid, PTSTR progID, CPerfData* pData);
    void CloseEffect();
    void SaveEffect(BOOL bSaveAs);

	BEGIN_MSG_MAP(CPanViewerView)
        MESSAGE_HANDLER(WM_SIZE, OnSize)
	END_MSG_MAP()

	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_image && m_image->GetHWND()) {
            ::SetWindowPos(m_image->GetHWND(), HWND_TOP,  0, 0, LOWORD(lParam), HIWORD(lParam), SWP_NOMOVE); 
        }
        bHandled = false;
        return 0;
    }
    CEffect* GetEffect() { return m_image; }

private:
    CEffectFactory* m_imgFact;
    CEffect* m_image;
    int *m_pDisplayPasses; double *m_pMaxJitter;  // For multi-pass rendering.
    CComBSTR m_bstrDocURL;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PANVIEWERVIEW_H__EDC98D59_E8BC_447D_AF4D_32CD209A8207__INCLUDED_)
